package org.heliostat;

import lejos.nxt.Button;
import lejos.nxt.LCD;
import lejos.nxt.Motor;
import lejos.util.TimerListener;
import lejos.util.*;

public class Heliostat implements TimerListener {
    /**
     * @param args
     */
	public static int waitForTimer=0;
	public static SunTracking st=new SunTracking();
	public static int delayTimer=5000;
	
    public static void main(String[] args) {
        System.out.println("Heliostato!!!");
        double[] solarLocation=new double[2];
        double[] mirrorLocation=new double[2];
        
        Motor.A.setSpeed(5);
        Motor.B.setSpeed(5);
        
        st.latitude=37; st.longitude=-5; st.targetAzimuth=160; st.targetElevation=15;
    	st.timeZone=2; st.month=12; st.day=29; st.hour=14; st.minutes=25; st.seconds=0;
    	
    	Timer timer = new Timer(delayTimer, new Heliostat());
        timer.start();
              
        while (!Button.ESCAPE.isDown())
        {
        	waitForTimer=1;
        	LCD.clearDisplay();
        	st.calculate(solarLocation, mirrorLocation);
        	System.out.println("Heliostato");
        	System.out.println(st.day+"/"+st.month+" "+st.hour+":"+st.minutes+":"+st.seconds);
        	System.out.println("Azimuth: "+mirrorLocation[0]);
        	System.out.println("Elevation: "+mirrorLocation[1]);
        	Motor.A.rotateTo((int)(mirrorLocation[0]-90.0), true);
        	Motor.B.rotateTo((int)(mirrorLocation[1]), true);
        
        	while (waitForTimer==1 && !Button.ESCAPE.isDown());
        }
 
    }
    
    public void timedOut() {
    	int seconds;
    	int minutes;
    	int hours;
    	
    	hours=this.st.hour;
    	seconds=this.st.seconds;
    	minutes=this.st.minutes;
    	
    	seconds+=delayTimer/1000;
    	
    	if (seconds>=60)
    	{
    		minutes++;
    		seconds-=60;
    	}

    	if (minutes>=60)
    	{
    		hours++;
    		minutes-=60;
    	}
    	
    	this.st.seconds=seconds;
    	this.st.minutes=minutes;
    	this.st.hour=hours;
    	waitForTimer=0;
    } 
}